{% load static %}
{% load i18n %}

{% block content %}
    <!-- Highcharts CDN -->
    <script src="{% static 'vendor/highcharts/highstock.js' %}"></script>
    <script src="{% static 'vendor/highcharts/no-data-to-display.js' %}"></script>
    <script src="{% static 'vendor/highcharts/exporting.js' %}"></script>
    <script src="{% static 'vendor/highcharts/export-data.js' %}"></script>

    <div id="graphs" class="panel panel-default panel-main">
        <div class="panel-heading cst_pad_right">
            <button type="button" class="toggle" title="{% trans 'Colapsar/Expandir' %} {% trans 'Gráficos' %}" style="margin-left: 4px;">
                <span class="glyphicon glyphicon-stats"></span>
            </button>

            <span class="hidden">
                <i class="glyphicon glyphicon-stats"></i>
                <span class="center"><strong>{% trans "Gráficos" %}</strong></span>
            </span>
        </div>
        <div class="panel-body main-body hidden">
            <div id="chart-container"></div>
        </div>
    </div>

<script type="text/javascript">
    // Global vars
    var charts = {};
    var colors = [];
    var stat_selection = {};

    var getModelledData = function(chart, layer, lower_point, upper_point, min_time, max_time, level, callback) {
        var url = servicepath + '?VERSION=1.1.1&REQUEST=GetTimeseries&SRS=EPSG:4326';
        url += '&LAYERS=' + layer;
        url += '&QUERY_LAYERS=' + layer;
        url += '&X=1&Y=1&I=1&J=1';
        url += '&BBox=' + lower_point.lng + ',' + lower_point.lat + ',' + upper_point.lng + ',' + upper_point.lat;
        url += '&WIDTH=2&HEIGHT=2';
        url += '&INFO_FORMAT=text/csv';
        url += '&TIME=' + min_time.toISOString() + '/' + max_time.toISOString();

        if (level) url += '&ELEVATION=' + (level - 1);

        var oReq = new XMLHttpRequest();
        oReq.addEventListener("load", (function(xhr) {
            var result = [];

            try {
                // Get data
                var response = xhr.currentTarget.response;
                var csvlines = response.split(/\r\n|\n/);

                // Parse data
                for (var i=0; i<csvlines.length; i++) {
                    if (Number.isInteger(parseInt(csvlines[i].charAt(0)))) {
                        var cols = csvlines[i].split(',');
                        var this_time = new Date(cols[0]).getTime(); // cols[0];
                        var this_data = cols[1];

                        if (cols.length > 2) {
                            var this_angle = cols[2];
                            try {
                                this_angle = Math.round(parseFloat(this_angle));
                            } catch (e) {
                                this_angle = null;
                            }
                        } else {
                            this_angle = null;
                        }

                        try {
                            this_data = parseFloat(this_data);
                        } catch (e) {
                            this_data = null;
                        }

                        if (this_angle) {
                            result.push({x: this_time, y: this_data, dir: this_angle});
                        } else {
                            result.push({x: this_time, y: this_data});
                        }
                    }
                }

                if (callback !== undefined) {
                    callback(result, chart);
                }
            } catch (err) {
                console.log(err);
                chart.hideLoading();
                show_alert_chart(chart, '{% trans "Erro a carregar série modelada." %}');
            }
        }));
        oReq.overrideMimeType('text/plain');
        oReq.open("GET", url);
        oReq.onerror = function () {
            chart.hideLoading();
            show_alert_chart(chart, '{% trans "Erro a carregar série modelada." %}');
        };
        oReq.send();
    };

    // Getting observation data from Emodnet client-side does not work because of CORS :(
    /*
    var getObservedData = function(chart, platformID, parameter, min_time, max_time, callback) {
        min_time = min_time.replace('-', '/');
        max_time = max_time.replace('-', '/');

        // Get from Emodnet
        var url = 'http://www.emodnet-physics.eu/Map/service/WSEmodnet2.aspx?q=GetAllLatestDataFromTo&PlatformID=';
        url += platformID + '&StartDate=' + min_time + '&EndDate=' + max_time

        var oReq = new XMLHttpRequest();
        oReq.addEventListener("load", (function(xhr) {
            var result = [];

            // Get data
            try {
                var response = xhr.currentTarget.responseXML;
                response.querySelectorAll('LatestData').forEach(function(fi) {
                    var strtime = fi.querySelector('Date').textContent.replace(/\//g, '-').replace(' ', 'T') + ':00.000Z';
                    var this_time = new Date(strtime).getTime();

                    var this_data = fi.querySelector('ParamValue').textContent.split(';');
                    for (var i=0; i<this_data.length; i++) {
                        var param = this_data[i].split("=");
                        if (param[0] == parameter) result.push([this_time, parseFloat(param[1].replace(',', '.'))]);
                    }
                });

                // Sort result array if has values
                if (result.length > 0) {
                    result = result.sort(sortTimes);
                }

                if (callback !== undefined) {
                    callback(result, chart);
                }
            } catch (err) {
                console.log(err);
                chart.hideLoading();
                show_alert_chart(chart, '{% trans "Erro a carregar série observada." %}');
            }
        }));
        oReq.overrideMimeType('application/xml');
        oReq.open("GET", url);
        oReq.onerror = function () {
            chart.hideLoading();
            show_alert_chart(chart, '{% trans "Erro a carregar série observada." %}');
        };
        oReq.send();
    };

    function sortTimes(a, b) {
        if (a[0] < b[0]) return -1;
        if (a[0] > b[0]) return 1;
        return 0;
    }
    */

    var getObservedData = function(chart, platformID, parameter, min_time, max_time, callback) {
        var url = 'get_station_data/' + platformID + '/' + parameter + '/' + min_time + '/' + max_time;

        var oReq = new XMLHttpRequest();
        oReq.addEventListener("load", (function(xhr) {
            var result = [];

            // Parse data
            var response = JSON.parse(xhr.currentTarget.response);
            var parameter = response['parameter'];

            if (parameter != '') {
                var data_arr = response['data'];
                for (var i=0; i<data_arr.length; i++) {
                    result.push([data_arr[i][0], data_arr[i][1]]);
                }

                if (callback !== undefined) {
                    callback(result, chart);
                }
            } else {
                chart.hideLoading();
                show_alert_chart(chart, '{% trans "Erro, parâmetro não encontrado." %}');
            }
        }));
        oReq.overrideMimeType('application/json');
        oReq.open("GET", url);
        oReq.onerror = function () {
            chart.hideLoading();
            show_alert_chart(chart, '{% trans "Erro a carregar série observada." %}');
        };
        oReq.send();
    };

    function loadSerie(chart, layer, lower_point, upper_point, min_time, max_time, color, station_name, station_type, station_code, level, max_level) {
        chart.showLoading();

        // Get modelled series data for each theme
        getModelledData(chart, layer, lower_point, upper_point, min_time, max_time, level, function(result, chart) {
            var keys = null;
            if (chart.options.id == "uvgroup") keys = ['y','dir']; // important to consider keys when exporting data other than "y"

            // Add serie to chart
            chart.addSeries({
                'id': encodeURI(station_name),
                'name': station_name,
                'type': "line",
                'color': color,
                'data': result,
                'keys': keys,
                'tooltip': {
                    'xDateFormat': "%Y-%m-%d %H:%M",
                    'pointFormatter': function () {
                        if (this.dir) {
                            return '<span style="color:' + this.color + '">\u25CF</span> '
                                + this.series.name + '<br/> <b>' + parseFloat(this.y).toFixed(2) + chart.options.units + ' | ' + this.dir + 'º' + '</b><br/>';
                        } else {
                            return '<span style="color:' + this.color + '">\u25CF</span> '
                                + this.series.name + '<br/><b>' + parseFloat(this.y).toFixed(2) + chart.options.units + '</b><br/>';
                        }
                    }
                },
                'dataLabels': {
                    'enabled': chart.options.id == "uvgroup",
                    'useHTML': chart.options.id == "uvgroup",
                    'formatter': function () {
                        if (this.point.y > 0) {
                            var d = document.createElement('svg');
                            $(d).css('width', '10px');
                            $(d).css('height', '10px');
                            $(d).css('transform', 'rotate(' + this.point.dir + 'deg)');

                            var p = document.createElement('path');
                            $(p).attr('d', 'm8.4107 3.2638c0.14104 0.14104 0.14104 0.36308 0 0.50412-0.13627 0.13627-0.36308 0.13627-0.49904 0l-2.5562-2.5562v8.4353c0 0.19663-0.15629 0.35291-0.35291 0.35291-0.19663 0-0.358-0.15629-0.358-0.35291v-8.4356l-2.5511 2.5562c-0.14104 0.13627-0.36816 0.13627-0.50412 0-0.14104-0.14104-0.14104-0.36308 0-0.50412l3.1613-3.1613c0.13627-0.13627 0.36308-0.13627 0.49904 0z')
                            $(p).attr('stroke', color);

                            $(d).append(p);
                            return $(d)[0].outerHTML;
                        }
                    }
                }
            }, false);

            // if comparision station
            if (station_type == 'C') {
                if (chart.options.theme == 'elev' || (chart.options.theme == 'temp' || chart.options.theme == 'salt' && level == max_level)) {
                    var platformID = station_code.split('_')[1];    // Get observation id. It was [2] edited to [1]

                    // Parse time to Emodnet format
                    var strmin_time = padLeft(min_time.getDate(), 2) + '-' + padLeft(Number(min_time.getMonth()+1), 2) + '-' + String(min_time.getFullYear());
                    var strmax_time = padLeft(max_time.getDate(), 2) + '-' + padLeft(Number(max_time.getMonth()+1), 2) + '-' + String(max_time.getFullYear());

                    // Get observed data from Emodnet server-side
                    getObservedData(chart, platformID, chart.options.theme, strmin_time, strmax_time, function(result, chart) {
                        if (result.length > 0) {
                            var name = station_name + ' (obs)';

                            // Add serie to chart
                            chart.addSeries({
                                'id': encodeURI(name),
                                'name': name,
                                'type': 'line',
                                'color': color,
                                'lineWidth': 3,
                                'marker': {
                                    'enabled': true,
                                    'radius': 1,
                                    'fillColor': "#000"
                                },
                                'tooltip': {
                                    'xDateFormat': "%Y-%m-%d %H:%M",
                                    'pointFormatter': function () {
                                        return '<span style="color:' + this.color + '">\u25CF</span> '
                                            + this.series.name + '<br/><b>' + parseFloat(this.y).toFixed(2) + chart.options.units + '</b><br/>';
                                    }
                                },
                                'data': result
                            }, false);
                        } else {
                            show_alert_chart(chart, '{% trans "Não existem dados observados<br/> para este período." %}');
                        }

                        // Finally
                        chart.redraw();
                        chart.hideLoading();
                    });
                } else {
                    // Finally
                    chart.redraw();
                    chart.hideLoading();

                    show_alert_chart(chart, '{% trans "Não existem dados observados<br/> para este período." %}');
                }
            } else {
                // Finally
                chart.redraw();
                chart.hideLoading();
            }
        });
    }

    function unloadSeries(station_id) {
        // Loop through charts
        $(Highcharts.charts).each(function(i, chart) {
            
            // Loop through chart series, mark to remove if serie exists
            var del_charts = [];
            var container_render = $(this)[0].renderTo;
            for (var j=0; j<chart.series.length; j++) {
                $(container_render).hide();
                var serie = decodeURI(chart.series[j].options.id).split(" (")[0];
                if (serie == station_id) del_charts.push(chart.series[j].options.id);
            }

            // Remove serie from chart
            for (var i=0; i<del_charts.length; i++) {
                chart.get(del_charts[i]).remove();
            }

        });
    }

    function loadChart(deploy, lower_point, upper_point, color, station_name, station_type, station_code, level, max_level, chart) {
        // Check if wms is loaded
        var layer_id = deploy + '-' + chart.options.id;
        l_prefix = "{{ wms_did }}".replace('{id}','')
        var dataset = l_prefix + deploy + '/';

        try {
            var service = services[layer_id];
            var times = service._availableTimes;
            if (times.length == 0) times = map.timeDimension.getAvailableTimes();

            var min_time = new Date(times[0]);
            var max_time = new Date(times[times.length-1]);

            // Set layer
            var layer = dataset + chart.options.theme;

            // If elevation chart - no level is applicable
            if (chart.options.id == 'elev') {
                level_nr = null;
            } else {
                level_nr = level - 1;
                station_name += " (" + level + ")";
            }

            // Load Serie data
            loadSerie(chart, layer, lower_point, upper_point, min_time, max_time, color, station_name, station_type, station_code, level_nr, max_level);
        } catch (err) {
            show_alert_chart(chart, '{% trans "Não existem dados modelados<br/> para este período." %}');
            return;
        }
    }

    function removeStationSeries(station_name) {
        var station_id = station_name.split(" (")[0];
        unloadSeries(station_id);
    }

    // Update PlotLine position in charts with timedimension current time
    function update_charts_plotlines() {
        var time = new Date(map.timeDimension.getCurrentTime());

        // Loop through charts
        $(Highcharts.charts).each(function(i, chart) {
            chart.xAxis[0].options.plotLines[0].value = time;
            chart.xAxis[0].update();
        });
    }

    // Show alert on a specific chart
    function show_alert_chart(chart, message) {
        var chart_width = chart.chartWidth/2.5, chart_height = chart.chartHeight/2.5;
        var label = chart.renderer.label(message, chart_width, chart_height)
            .attr({
                fill: Highcharts.getOptions().colors[0],
                padding: 10,
                r: 5,
                zIndex: 8
            })
            .css({
                color: '#FFFFFF'
            })
            .add();

        setTimeout(function () {
            label.fadeOut();
        }, 8000);
    }

    function valVars(elem) {
        // If checkbox is elevation
        if ($(elem).prop("checked") && $(elem).val() == 'elev') {
            var deploy = $(elem).attr('name').split('_')[1];
            // Get modal object
            var modal = $("#modal_" + deploy);
            // Select Surface Level
            $(modal).find('input[name="levels_' + deploy + '"]:first').prop('checked', true);
        }
    }

    function openPopup(deploy, station_name, station_code) {
        // Get modal object
        var modal = $("#modal_" + deploy);

        // Clear error messages on modal load
        $(modal).find(".text-danger").hide();

        // Clear all checkbox inputs
        $(modal).find('input[type=checkbox]').prop('checked', false);

        // Set title
        $(modal).find(".modal-title").html(station_name);

        // If one level only - checked by default
        if ($(modal).find('input[name=levels_' + deploy + ']').length === 1) {
            $(modal).find('input[name=levels_' + deploy + ']').prop('checked', true);
        }

        // Fill form with previous selection
        if (station_code in stat_selection) {
            var vars = stat_selection[station_code]["vars"];
            var levels = stat_selection[station_code]["levels"];

            for (var i= 0; i<vars.length; i++) {
                $(modal).find('input[name=vars_' + deploy + '][value="' + vars[i] + '"]').prop('checked', true);
            }

            for (var i= 0; i<levels.length; i++) {
                $(modal).find('input[name=levels_' + deploy + '][value="' + levels[i] + '"]').prop('checked', true);
            }
        }

        // Finally open modal
        $(modal).modal('show');
    }

    $(function() {
        Highcharts.setOptions({
            global: {
                useUTC: true
            }
        });

        var btn_options = ["printChart", "downloadCSV", "downloadXLS"];

        // Create chart per nr of themes in one deployment
        $('input[type="checkbox"][name="theme"]').each(function() {
            var chart_id = $(this).attr('id');
            var theme = $(this).data('theme');
            var label = $(this).data('name');
            var unit = $(this).data('unit');

            // Create one chart per distinct theme
            if (!(label in charts)) {
                var chart_container = document.getElementById('chart-container');
                var container = document.createElement('div');
                $(container).attr('id', chart_id);
                $(container).addClass('chart');
                $(container).hide();
                chart_container.appendChild(container);

                // console.log("---- LABEL ----");
                // console.log(label);

                var chart_options = {
                    'id': chart_id,
                    'theme': theme,
                    'label': label,
                    'units': unit,
                    'title': {
                        'text': "<span class='label label-primary'>" + label + "</span>",
                        'useHTML': true
                    },
                    'legend': {
                        'enabled': true
                    },
                    'chart': {
                        'zoomType': "x",
                    },
                    'navigator': {
                        'enabled': false,
                    },
                    'xAxis': {
                        'type': "datetime",
                        'ordinal': false,
                        'plotLines': [{
                            'color': "#337ab7",
                            'dashStyle': "solid",
                            'width': 2,
                            'id': "pbCurrentTime"
                        }]
                    },
                    'rangeSelector': {
                        'buttons': [{
                            'type': "day",
                            'count': 1,
                            'text': "1D"
                        }, {
                            'type': "all",
                            'count': 1,
                            'text': "All"
                        }],
                        'enabled': false,
                        'inputEnabled': false,
                        'selected': 1,
                        'inputDateFormat': "%Y-%m-%d %H:%M",
                        'inputBoxWidth': 110,
                    },
                    'series': [],
                    'plotOptions': {
                        'series': {
                            'cursor': 'pointer',
                            'point': {
                                'events': {
                                    'click': (function(event) {
                                        // update timedimension on chart click
                                        var day = new Date(event.point.x);
                                        map.timeDimension.setCurrentTime(day.getTime());
                                    }).bind(this)
                                }
                            },
                        }
                    },
                    'lang': {
                        'noData': "{% trans 'sem dados' %}",
                        'loading': "{% trans 'a carregar série...' %}"
                    },
                    'exporting': {
                        'enabled': true,
                        'filename': "opencoasts_chart",
                        'csv': {
                            'dateFormat': "%Y-%m-%d %H:%M"
                        },
                        'buttons': {
                            'contextButton': {
                                'menuItems': btn_options
                            }
                        },
                        'chartOptions': {
                            'plotOptions': {
                                'series': {
                                    'dataLabels': {
                                        'enabled': true
                                    }
                                }
                            }
                        }
                    }
                };

                // Save to dictionary array
                charts[label] = Highcharts.stockChart(container, chart_options);
            }
        });

        // add random color to each station
        // to render each station in all charts with the same color
        var n = 0, nrcolors = $('button.view-popup').length;
        $('button.view-popup').each(function(){
            var color = getRandomColors(n, nrcolors);
            $(this).attr('data-color', color);

            // Add station graph legend
            var div = '<span class="serie-leg" title="{% trans "Legenda das séries" %}"><i class="line" style="background-color:' + color + '"></i></span>'
            $(div).insertBefore(this);

            // Push to array so we can check if new random stations have the
            // same color as user defined stations
            colors.push(color);
            n += 1;
        });

        // Action on station selection/unselection
        $('button.add-charts').click(function() {
            var deploy = $(this).data('deploy');

            var text_id = [];

            // Check which variables and levels are selected
            var vars_ids = [];
            $('input[type="checkbox"][name="vars_' + deploy + '"]:checked').each(function() {
                var test_child = $(this).parent().children()[1];
                text_id.push(test_child.innerHTML);
                vars_ids.push($(this).val());
            });

            // console.log("---- VARS_IDS --------");
            // console.log(vars_ids);

            var levels_ids = [];
            $('input[type="checkbox"][name="levels_' + deploy + '"]:checked').each(function() {
                levels_ids.push($(this).val());
            });

            // if non selected warn user
            if (vars_ids.length == 0 || levels_ids.length == 0) {
                $("#modal_" + deploy + " .text-danger").html('{% trans "Selecione pelo menos uma combinação para adicionar aos gráficos" %}');
                $("#modal_" + deploy + " .text-danger").show();
            } else if (vars_ids.indexOf('elev') > -1 && $('input[type="checkbox"][name="levels_' + deploy + '"]:first').prop("checked") == false) {
                $("#modal_" + deploy + " .text-danger").html('{% trans "Para a variável Elevação terá de selecionar o nível à Superfície" %}');
                $("#modal_" + deploy + " .text-danger").show();
            } else {
                // Expand Graph Panel if collapsed
                if ($('.panel-center').width() === nav_collapsed_width) {
                    var navid = $('.panel-center').find('.panel-main').get(0).id;
                    var spanelem = $('.panel-center').find('button.toggle span');
                    togglePanel(navid, spanelem);
                }

                var station_code = $("#stat_code_" + deploy).val();
                var station_name = $("#stat_name_" + deploy).val();
                var station_type = $("#stat_type_" + deploy).val();
                var lat = parseFloat($("#stat_lat_" + deploy).val());
                var lon = parseFloat($("#stat_lon_" + deploy).val());
                var color = $("#stat_color_" + deploy).val();

                // If map click point and not yet added to the map
                if (station_type == 'R' && !(pointInGroup(station_code))) {
                    // Map click - add point to map (only once)
                    addPoint2Map(deploy, station_code, station_name, lat, lon, color);
                }

                // Save selection to global variable
                stat_selection[station_code] = {"vars": vars_ids, "levels": levels_ids};

                // Remove all deployment's series
                removeStationSeries(station_name);

                // Get position
                var lower_point = new L.latLng(lat, lon);
                var upper_point = new L.latLng(lat + 0.0001, lon + 0.0001);

                // Loop through charts
                $(Highcharts.charts).each(function(i, chart) {
                    // Only try to load charts if in themes list

                    var container_render = $(this)[0].renderTo;

                    if (vars_ids.indexOf(chart.options.id) > -1) {
                        if (chart.options.id == "elev") {
                            $(container_render).show();
                            var level = levels_ids[0];
                            loadChart(deploy, lower_point, upper_point, color, station_name, station_type, station_code, level, null, chart);
                        } else {
                            for (var i=0; i<levels_ids.length; i++) {
                                // console.log("---- LABEL TEXT ---");
                                // console.log(text_id);
                                // console.log(chart.options.label);
                                if(text_id.includes(chart.options.label)){
                                    $(container_render).show();
                                    var level = levels_ids[i];
                                    var max_level = levels_ids[levels_ids.length-1];
                                    loadChart(deploy, lower_point, upper_point, color, station_name, station_type, station_code, level, max_level, chart);
                                }
                            }
                        }
                    }
                });

                // Close modal
                $("#modal_" + deploy).modal('hide');
            }
        });

        $('button.view-popup').click(function() {
            var deploy = $(this).data('deploy');
            var station_code = $(this).data('code');
            var station_name = 'ID:' + deploy + ', ' + $(this).data('name');

            // Fill hidden inputs
            $("#stat_code_" + deploy).val(station_code);
            $("#stat_name_" + deploy).val(station_name);
            $("#stat_type_" + deploy).val($(this).data('type'));
            $("#stat_lat_" + deploy).val($(this).data('lat'));
            $("#stat_lon_" + deploy).val($(this).data('lon'));
            $("#stat_color_" + deploy).val($(this).data('color'));

            // Set and open modal
            openPopup(deploy, station_name, station_code);
        });

        $('button.clear-modal').click(function() {
            var deploy = $(this).data('deploy');
            // Get modal object
            var modal = $("#modal_" + deploy);

            // Clear all checkbox inputs
            $(modal).find('input[type=checkbox]').prop('checked', false);

            // Clear series from charts if exist
            var station_name = $("#stat_name_" + deploy).val();
            removeStationSeries(station_name);

            // Clear from global variable
            var stat_id = $("#stat_code_" + deploy).val();
            delete stat_selection[stat_id];
        });
    });
</script>

{% endblock content %}
